/*
 * Copyright 2021-2022 Xilinx, Inc
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
#include "agent_common.h"
#include "multiboot.h"

/* ------------------------------------------------------------------ */

int main(void)
{
    MultibootState tMultibootState;
    MultibootState* pMS = &tMultibootState;

    WAIT_FOR_PLM_DONE();

    GrabSysMutex();
        TRACE_PRINT("%04x: Build info: %s %s\n\r",SYS_MUTEX_MASTER_ID,__DATE__,__TIME__);
    ReleaseSysMutex();

    TRACE();
    InitMultibootState(&tMultibootState);
    TRACE();

    for(;;) {
        SenseMultibootInputs(pMS);

        if(pMS->yMultibootRequest || (PCIE_STATE_DOWN == pMS->ePcieState)) {
            TRACE();
            PerformMultiboot(pMS);
            __builtin_unreachable();
            for(;;) {
                ;
            }
        }
        TRACE();
    }
    return 0;
}
