/*
 * Copyright 2021-2022 Xilinx, Inc
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
#ifndef X86_AGENT_DEVICE_H__
#define X86_AGENT_DEVICE_H__

struct AgentData;
typedef struct AgentData AgentData;

/*
 * 2MiB: This is the minimum size of the BAR that exposes the TCM+OCM
 */
#define AGENT_MAP_MIN_SIZE                  (2*1024*1024)

struct AgentData {
    void* pxMap;
    uint32_t qMapSize;
};

bool OpenAgent(Sys* pSys);
bool CloseAgent(Sys* pSys);

#endif  /* X86_AGENT_DEVICE_H__ */
